Subject: Re: [Emacs-diffs] master 2c8a7e5: Improve diff-mode navigation/manipulation

From: Mark Oteiza <[email-masked]>
Date: Thu, 5 Jan 2017 21:58:11 -0500

On 06/12/16 at 11:29pm, Dima Kogan wrote:
> Mark Oteiza <[email-masked]> writes:
> 
> > Fixing C-c C-a to DTRT is great, thanks, but I don't think the
> > off-by-one navigation changes to "n" and "p" (diff-hunk-next,
> > diff-hunk-prev) make sense. While it may have made fixing the issues
> > mentioned in the commit message easier, the changes to what "n" and "p"
> > do at the beginning and end of a diff are not documented, and I didn't
> > see any discussion of it in the associated bug.
> >
> > I contend that the new behavior is inconsistent with the behavior of
> > other outline/thing-with-headers type things in Emacs.  outline-mode,
> > org-mode, and rst-mode are the first ones that come to mind.
> 
> Can you give a specific example of interaction in any of these modes
> that is analogous to the off-by-one behavior you're referring to?

I wrote about how your changes are make diff-mode _not_ analogous.

> The
> fundamental question is what hunk diff-mode should think the point is
> looking at, when it is in some non-diff message above the first hunk.
> The answer I chose for the new navigation logic is "first hunk". You
> could also choose "invalid hunk, not a hunk at all", which would imply
> that C-c C-a and M-ret and such shouldn't work there. Better suggestions
> welcome.

One might argue that C-c C-a and friends in a file header should apply
all hunks in a file, or perhaps that there should actually be
diff-apply-file commands, etc.

The way n and p worked was not a bug, yet you gratuitously changed them,
and broke auto-refinement.  Why do I have to now hit two keys to refine
the first hunk, and one key to refine the second?

> > It's also not clear how the introduced oddity with auto-refine is going
> > to be resolved, unless a way is found to autorefine the first hunk
> > without there being any user interaction.  Then opening a diff has
> > inconsistent auto-refining from the start.
> 
> I don't use auto-refinement, so didn't notice the breakage. Will look at
> it in a bit.

It's on by default, so this statement perplexes me.